; FrameRector v.2008-08-31
; http://www.geocities.com/xmemor/2lz/tinyasm.html

.386
.model flat,stdcall
option casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

.const
WS_EX_LAYERED	equ 80000h
LWA_ALPHA			equ 2h

.data
appname	db "FrameRector",0
about		db "by kero <geocities.com/xmemor>, v.2008-08-31",0
;; output string:  hWnd / dwpHT / smHT / status / regiontype / sgn / xy / rect / layer / CtrlID / class / text / exefile / procID / threadID
frmt		db "   %8.8X  <HT %d/%d>  %s%s  %lu  %s(%d,%d)   [%d,%d; %lu*%lu]   %s=%lu  cid=%lu  {%s}  ""%s""  <%s>  %s=%lu  %s=%lu",0
frmt2		db "   pt (%d,%d)   rect (%d,%d; %lu*%lu)",0
sgn			db "+",0
status	db "_ve",0
zn			db "n",0
zpid		db "pid",0
ztid		db "tid",0
mow			db "MOW  ",0
;tout		db "<<FR_timeout_error>>",0
;lf      LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">

.data?
pt			POINT <?>
pt0			POINT <?>
rt			RECT <?>
pe32		PROCESSENTRY32 <?>
osvi		OSVERSIONINFO <?>
osv			dd ?
hdesk		dd ?
hwin		dd ?
dwp_ht  dd ?   ; DefWindowProc        WM_NCHITTEST result
sm_ht   dd ?   ; SendMessage(Timeout) WM_NCHITTEST result
hwprnt	dd ?
hwbrnch	dd ?
exstyle	dd ?
hdc			HDC ?
hbr_b		dd ?
hbr_w		dd ?
hbr_x		HBRUSH ?
hbr_r		HBRUSH ?
hbr			dd ?
cid			dd ?
pid			dd ?
pid0		dd ?
tid			dd ?
tid0		dd ?
hSnap		HANDLE ?
hrgn		HRGN ?
hrgn0		HRGN ?
hrgn2		HRGN ?
trgn		dd ?		; regiontype: 0 ("window hasn't region" or ERROR), 1 (NULLREGION), 2 (SIMPLEREGION), 3 (COMPLEXREGION)
count		dd ?
countx	dd ?
count0	dd ?
way			dd ?
filter	dd ?
rflag		dd ?
exit		dd ?
alpha		dd ?
xx			dd ?
yy			dd ?
wdth		dd ?
hght		dd ?
uflags	dd ?
mess_id	dd ?
mo			db ?
buf0		db 1024 dup(?)
buf			db 1024 dup(?)
buf2		db 1024 dup(?)
buf3		db MAX_PATH dup(?)
buf4		db MAX_PATH dup(?)
bufdesk	db 1024 dup(?)
hmess		dd ?
;hfont   HFONT ?
;hfntold HFONT ?

.code

;#############################################################################################################################

TxtOut proc
	invoke	lstrcmp,addr buf,addr buf2
	test	eax,eax
	jz	@f
	invoke	TextOut,hdc,0,0,addr buf0,1023
	invoke	lstrcpy,addr buf2,addr buf
	invoke	lstrlen,eax
	invoke	TextOut,hdc,0,0,addr buf,eax
	invoke	SendMessageTimeout,hdesk,WM_SETTEXT,0,addr buf,SMTO_ABORTIFHUNG,20,0
	invoke	SendMessageTimeout,HWND_BROADCAST,mess_id,hdesk,hwin,SMTO_ABORTIFHUNG,20,0
@@:
	ret
TxtOut endp

;#############################################################################################################################

IsKey proc vkey:DWORD
	invoke	GetKeyState,vkey
	test	ax,8000h
	ret
IsKey endp

;#############################################################################################################################

EnChProc proc uses ebx hWnd:HWND,param:DWORD

	invoke	IsKey,VK_INSERT
	jz	@f
	inc	exit
	xor	eax,eax
	ret
@@:
	invoke	IsKey,VK_CONTROL
	jz @f
	invoke IsWindowVisible,hWnd
	test eax,eax
	jz @1
@@:
	invoke	GetWindowThreadProcessId,hWnd,addr pid
	mov ecx,filter
	cmp	ecx,2
	jnz	@f
	cmp	eax,tid0					; ThreadID filter
	jnz	@1
@@:
	cmp	ecx,1
	jnz	@f
	mov	eax,pid
	cmp	eax,pid0					; ProcessID filter
	jnz	@1
@@:
	cmp ecx,3
	jnz @@@
	mov ebx,hWnd
@@:
	cmp ebx,hwbrnch					; window branch filter
	jz @@@
	invoke GetWindowLong,ebx,GWL_STYLE
	test eax,WS_CHILD
	jz @1
	invoke GetWindowLong,ebx,GWL_HWNDPARENT
	mov ebx,eax
	jmp @b
@@@:
	invoke	GetWindowRect,hWnd,addr rt
 	mov	eax,hbr_b					; black frame
	mov	hbr,eax
	mov	eax,pt.x					; is point (edge of cursor) within rectangle ?
	sub	eax,rt.left
	jl	@out
	mov	ecx,rt.right
	sub	ecx,pt.x
	jl	@out
	mov	edx,pt.y
	sub	edx,rt.top
	jl	@out
	mov	ebx,rt.bottom
	sub	ebx,pt.y
	jl	@out
	inc	count
	cmp	count0,0
	jnz	@n
	cmp	eax,ecx						; hwin from point (search immediate rectangle)
	jle	@f
	mov	eax,ecx
@@:
	cmp	eax,edx
	jle	@f
	mov	eax,edx
@@: 
	cmp	eax,ebx
	jle	@f
	mov	eax,ebx
@@:
	cmp	eax,way
	jge	@f
	mov	way,eax
	mov	eax,count
	jmp @hw
@n:
	mov	eax,count	
	cmp	eax,count0				; window z-layer (N) filter
	jnz	@f
@hw:
	mov	countx,eax
	mov	eax,hWnd
	mov	hwin,eax
	mov al,mo							; message-only window ?
	mov byte ptr [mow],al
@@:	
	mov	eax,hbr_w					; white frame
	mov	hbr,eax
@out:
	invoke	FrameRect,hdc,addr rt,hbr			; within => white frame, else => black frame
@1:
	mov ecx,hWnd
	xor	eax,eax
	inc	eax
	ret
EnChProc endp

;#############################################################################################################################

start:

;		invoke RegisterWindowMessage,offset appname
; or
		invoke RegisterClipboardFormat,offset appname
; or
;		.data?
;		wcs		WNDCLASS <?>
;		.code
;		mov wcs.lpszClassName,offset appname
;		invoke RegisterClass,offset wcs
;		and eax,0ffffh
	test eax,eax
	jz @quit
	mov mess_id,eax

	mov	osvi.dwOSVersionInfoSize,sizeof osvi
	invoke	GetVersionEx,addr osvi		
	mov	ecx,osvi.dwMajorVersion
	mov	osv,ecx	
	xor	eax,eax
	cmp	ecx,5						; is Win OS = 2k/XP/Server 2003/...  ?
	jae	@f	
	mov	osv,eax
@@:
;	mov	hrgn0,eax
	mov	trgn,eax
	mov	exit,eax
	mov	hwbrnch,eax

	mov	filter,eax
	mov	count0,eax
	mov	rflag,eax

	invoke	CreateRectRgn,eax,eax,eax,eax
	mov	hrgn,eax
	xor	eax,eax
	invoke	CreateRectRgn,eax,eax,eax,eax
	mov	hrgn0,eax
	mov	alpha,255

	xor	eax,eax
	.while	eax < 1023
		mov	byte ptr [buf0 + eax],' '
		inc	eax
	.endw

	invoke	GetStockObject,BLACK_BRUSH ; GRAY_BRUSH	;	DKGRAY_BRUSH ; 
	mov	hbr_b,eax
	invoke	GetStockObject,WHITE_BRUSH
	mov	hbr_w,eax
	invoke	CreateSolidBrush,Yellow			; 00FFFFh
	mov	hbr_x,eax
	invoke	CreateSolidBrush,Red				; 0000FFh
	mov	hbr_r,eax

	invoke	GetDesktopWindow
	mov	hdesk,eax
	invoke	GetWindowDC,eax
	mov	hdc,eax
	invoke SendMessageTimeout,hdesk,WM_GETTEXT,1023,addr bufdesk,SMTO_ABORTIFHUNG,20,0

;  invoke CreateFontIndirect,offset lf
;  mov hfont,eax
;  invoke SelectObject,hdc,hfont
;  mov hfntold,eax

	invoke	GetCursorPos,addr pt
@loop2:
	invoke	InvalidateRect,0,0,1
@loop3:
	invoke	Sleep,100
@loop:
	invoke	Sleep,20
	mov	way,7FFFFFFFh
	xor	eax,eax
	mov	hwin,eax
	mov	hwprnt,eax
	mov	count,eax
	mov	countx,eax
	mov mo,al

	mov	eax,pt.x
	mov	xx,eax
	mov	eax,pt.y
	mov	yy,eax
	invoke	GetCursorPos,addr pt

	invoke	EnumChildWindows,hdesk,addr EnChProc,0
	mov	eax,exit
	test	eax,eax
	jnz	@exit

	mov mo,'M'

;	xor ecx,ecx
;@@:
;	invoke FindWindowEx,HWND_MESSAGE,ecx,0,0		; find all (top-level) message-only windows
;	test eax,eax
;	jz @f
;	invoke EnChProc,eax,0
;	mov	eax,exit
;	test	eax,eax
;	jnz	@exit
;	jmp @b
;@@:

		invoke FindWindowEx,HWND_MESSAGE,0,0,0		; find any message-only windows
		test eax,eax
		jz @f
		invoke GetWindowLong,eax,GWL_HWNDPARENT   ; find ancestor message-only (class "Message")
;		invoke GetAncestor,eax,GA_PARENT
		mov hmess,eax
		invoke EnChProc,hmess,0
		invoke EnumChildWindows,hmess,addr EnChProc,0
@@:

	mov	eax,hwin
	test	eax,eax
	jnz	@f
	mov	eax,rflag
	test	eax,eax
	jnz	@key
	inc	rflag
	invoke	lstrcpy,addr buf2,addr buf0
	jmp	@key
@@:
	invoke	GetWindowLong,hwin,GWL_STYLE
	test	eax,WS_CHILD													; WS_CHILD=40000000h
	jz	@f
	invoke	GetWindowLong,hwin,GWL_HWNDPARENT
	mov	hwprnt,eax
	test	eax,eax
	jz	@f
	invoke	GetWindowRect,eax,addr rt
	invoke	FrameRect,hdc,addr rt,hbr_r
@@:
	invoke	GetWindowRect,hwin,addr rt
	mov	eax,rt.right
	sub	eax,rt.left
	mov	wdth,eax
	mov	eax,rt.bottom
	sub	eax,rt.top
	mov	hght,eax

	invoke	FrameRect,hdc,addr rt,hbr_x
	invoke	GetWindowRgn,hwin,hrgn
	mov	trgn,eax

	mov	byte ptr [sgn],'+'
	test	eax,eax
	jz	@f
	mov	eax,pt.x
	sub	eax,rt.left
	mov	ecx,pt.y
	sub	ecx,rt.top
	invoke	PtInRegion,hrgn,eax,ecx
	test	eax,eax
	jnz	@f
	mov	byte ptr [sgn],'-'				; point is inside hole of region
@@:
	xor	eax,eax
	mov	rflag,eax
	invoke	GetDlgCtrlID,hwin
	mov	cid,eax

	invoke	SendMessageTimeout,hwin,WM_GETTEXT,MAX_PATH-1,addr buf4,SMTO_ABORTIFHUNG,20,0			; timeout: 20 ms
	test eax,eax
	jnz @f
;	invoke lstrcpy,addr buf4,addr tout
;@@:
	invoke	GetWindowText,hwin,addr buf4,MAX_PATH-1
@@:
	invoke	GetClassName,hwin,addr buf3,MAX_PATH-1
	invoke	GetWindowThreadProcessId,hwin,addr pid
	mov	tid,eax
	invoke	CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,pid
	mov	hSnap,eax
	mov	pe32.dwSize,sizeof pe32 
	invoke	Process32First,eax,addr pe32 
@@:
	test	eax,eax
	jz	@false
	mov	eax,pid
	cmp	pe32.th32ProcessID,eax
	jz	@f
	invoke	Process32Next,hSnap,addr pe32
	jmp	@b
@false:
	mov	eax,offset pe32.szExeFile
	mov	word ptr [eax],[0]['?']				; "?",0
@@:
	mov	dword ptr [status],[0]['ev_']			; e(nable)v(isible)
	invoke	IsWindowEnabled,hwin
	test	eax,eax
	jnz	@f
	mov	byte ptr [status+2],'d'				; d(isable)
@@:
	invoke	IsWindowVisible,hwin
	test	eax,eax
	jnz	@f
	mov	byte ptr [status+1],'h'				; h(idden)
@@:
	invoke	GetWindowLong,hwin,GWL_EXSTYLE
	mov	exstyle,eax
	test	eax,WS_EX_LAYERED
	jz	@f
	mov	byte ptr [status],'a'				; a(lpha)
@@:
  mov eax,pt.x
  and eax,0ffffh
  mov ecx,pt.y
  shl ecx,16
  or eax,ecx
  push eax
  invoke DefWindowProc,hwin,WM_NCHITTEST,0,eax
  mov dwp_ht,eax
  pop ecx
  invoke SendMessageTimeout,hwin,WM_NCHITTEST,0,ecx,SMTO_ABORTIFHUNG,20,addr sm_ht
	invoke wsprintf,addr buf,addr frmt,hwin,dwp_ht,sm_ht,addr mow,addr status,trgn,addr sgn,pt.x,pt.y,rt.left,rt.top,wdth,\
			hght,addr zn,countx,cid,addr buf3,addr buf4,addr pe32.szExeFile,addr zpid,pid,addr ztid,tid
	invoke CloseHandle,hSnap
	invoke TxtOut

@key:

	invoke	IsKey,VK_F5 					; VK_F5 => refresh screen
	jnz	@loop2

	invoke	IsKey,VK_F8					  ; cursor + F8/(F8+F7) => move/resize window
	jz	@nxt
	xor	eax,eax
	mov	pt0.x,eax
	mov	pt0.y,eax
	mov	eax,hwprnt
	test	eax,eax
	jz	@movres
	invoke	ClientToScreen,eax,addr pt0
@movres:
	invoke	Sleep,20
	invoke	IsKey,VK_F8           ; cursor + (F8+F7) pressed => resize window
	jz	@loop2
	mov	eax,pt.x
	sub	xx,eax
	mov	eax,pt.y
	sub	yy,eax
	invoke	IsKey,VK_F7					  ; cursor + (F8+F7) pressed => resize window
	jz	@f
	mov	eax,xx
	sub	wdth,eax
	mov	eax,yy
	sub	hght,eax	
	mov	uflags,SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOMOVE
	jmp	@swp
@@:
	mov	eax,xx
	sub	rt.left,eax
	mov	eax,yy
	sub	rt.top,eax
	mov	ecx,rt.left
	sub	ecx,pt0.x
	mov	edx,rt.top
	sub	edx,pt0.y
	mov	uflags,SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOSIZE
@swp:
	invoke	SetWindowPos,hwin,0,ecx,edx,wdth,hght,uflags
	mov	eax,pt.x
	mov	xx,eax
	mov	eax,pt.y
	mov	yy,eax
	invoke	GetCursorPos,addr pt
	invoke	wsprintf,addr buf,addr frmt2,pt.x,pt.y,rt.left,rt.top,wdth,hght
	invoke	TxtOut
	invoke	GetWindowRect,hwin,addr rt
	invoke	FrameRect,hdc,addr rt,hbr_x
	jmp	@movres
@nxt:
	invoke	IsKey,VK_F7					; F7 => topmost/notopmost
	jz	@f
	mov	ecx,HWND_TOPMOST
	mov	eax,exstyle
	test	eax,WS_EX_TOPMOST				; WS_EX_TOPMOST equ 8h
	jz	@swp2
	mov	ecx,HWND_NOTOPMOST
@swp2:
	invoke	SetWindowPos,hwin,ecx,0,0,0,0,SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOMOVE
	jmp	@loop3
@@:
	invoke	IsKey,VK_F6					; F6 => mouse click emulation
	jz	@f

;	invoke	SendMessageTimeout,hwin,BM_CLICK,0,0,SMTO_ABORTIFHUNG,20,0

	invoke	SendMessageTimeout,hwin,WM_KEYDOWN,20h,0,SMTO_ABORTIFHUNG,20,0
	invoke	SendMessageTimeout,hwin,WM_KEYUP,20h,0,SMTO_ABORTIFHUNG,20,0

	jmp	@loop3
@@:
	invoke	IsKey,VK_F4					; F4 => enable/disable
	jz	@f
	mov	al,byte ptr [status+2]
	.if	al=='e'
		invoke	EnableWindow,hwin,0
	.elseif	al=='d'
		invoke	EnableWindow,hwin,1
	.endif
	jmp	@loop3
@@:
	invoke	IsKey,VK_F2					; F2 => show/hide
	jz	@f
	mov	al,byte ptr [status+1]
	.if	al=='v'
		invoke	ShowWindow,hwin,SW_HIDE
	.elseif	al=='h'
		invoke	ShowWindow,hwin,SW_NORMAL
	.endif
	jmp	@loop3

@@:
	invoke	IsKey,VK_ESCAPE			; Alt+Esc => close
	jz	@f
	invoke	IsKey,VK_MENU				; Alt+Esc => close
	jz	@f
	invoke	PostMessage,hwin,WM_CLOSE,0,0
	jmp	@loop3
@@:

	invoke	IsKey,VK_F9					; F9 => get window region
	jz	@f
	mov	eax,trgn
	test	eax,eax
	jz	@loop3
	invoke	GetWindowRgn,hwin,hrgn0
;	invoke	GetWindowRect,hwin,addr rt
	invoke	OffsetRgn,hrgn0,rt.left,rt.top
	invoke	FrameRgn,hdc,hrgn0,hbr_x,1,1
	xor	eax,eax
	sub	eax,rt.left
	xor	ecx,ecx
	sub	ecx,rt.top
	invoke	OffsetRgn,hrgn0,eax,ecx
	jmp	@loop3
@@:
	invoke	IsKey,VK_F10				; F10 => copy window region
	jz	@f
	xor	eax,eax
	invoke	CreateRectRgn,eax,eax,eax,eax			; empty region
	mov	hrgn2,eax
	invoke	CombineRgn,hrgn2,hrgn0,hrgn0,RGN_COPY
	invoke	SetWindowRgn,hwin,hrgn2,1
	invoke	DeleteObject,hrgn2
	jmp	@loop3
@@:
	invoke	IsKey,VK_F11				; F11 => set NULL window region / set ENTIRE HOLEY window region
	jz	@f
	xor	eax,eax
	invoke	CreateRectRgn,eax,eax,eax,eax
	mov	hrgn2,eax
	cmp	trgn,1
	jnz	@swr
	xor	eax,eax
@swr:
	invoke	SetWindowRgn,hwin,eax,1
	invoke	DeleteObject,hrgn2
	jmp	@loop2
@@:
	invoke	GetKeyState,VK_CAPITAL	; CAPS LOCK => PID0 capture on/off
	and	eax,1
	push	eax
	invoke	GetKeyState,VK_SCROLL		; SCROLL LOCK => TID0 capture on/off
	and	eax,1
	shl	eax,1
	pop	ecx
	or	eax,ecx
	cmp	eax,filter
	jz	@f
	mov	filter,eax
	mov	dword ptr [zpid],[0]['dip']
	mov	dword ptr [ztid],[0]['dit']
	mov	ecx,pid
	mov	pid0,ecx
	mov	ecx,tid
	mov	tid0,ecx
	.if eax==0
	.elseif eax==1
		mov	dword ptr [zpid],[0]['DIP']
	.elseif eax==2
		mov	dword ptr [ztid],[0]['DIT']
	.elseif eax==3
		mov	dword ptr [zpid],[0]['DIP']
		mov	dword ptr [ztid],[0]['DIT']
		mov ecx,hwin
		mov hwbrnch,ecx
	.endif
	jmp	@loop2
@@:
	invoke	GetKeyState,VK_NUMLOCK	 ; NUM LOCK => on/off
	and	eax,1	
	.if	eax==0
		.if	eax!=count0
			mov	word ptr [zn],[0]['n']
			mov	count0,eax
			jmp	@loop3
		.endif
	.else
		.if	count0==0
			mov	eax,countx
			mov	word ptr [zn],[0]['N']
			mov	count0,eax
			jmp	@loop3
		.else
			invoke	IsKey,VK_DOWN			  ; DOWN ARROW => inc count0
			jz	@f
			mov	eax,countx
			inc	eax
			.if	eax > count
				mov	eax,count
			.endif
			mov	count0,eax
			jmp	@loop3
@@:
			invoke	IsKey,VK_UP			   ; UP ARROW => dec count0
			jz	@f
			mov	eax,countx
			.if	eax > 2
				dec	eax
			.else
				xor	eax,eax
				inc	eax
			.endif
			mov	count0,eax
			jmp	@loop3
		.endif
	.endif
@@:
	mov	eax,osv						; is Win OS = 2k/XP/Server 2003/... ?
	test	eax,eax
	jz	@loop

	invoke	IsKey,VK_F12					; F12 => WS_EX_LAYERED on/off
	jz	@f
	cmp	byte ptr [status],'a'
	jnz	@gcl
	mov	eax,exstyle
	and	eax,not	WS_EX_LAYERED
	jmp	@swl
@gcl:
	invoke	GetClassLong,hwin,GCL_STYLE			; see MSDN (http://msdn.microsoft.com/library) - SetWindowLong - WS_EX_LAYERED
	test	eax,CS_CLASSDC or CS_OWNDC
	jnz	@loop3
	mov	eax,exstyle
	or	eax,WS_EX_LAYERED
@swl:
	invoke	SetWindowLong,hwin,GWL_EXSTYLE,eax
	jmp	@loop3
@@:
	cmp	byte ptr [status],'a'
	jnz	@loop

	invoke	IsKey,VK_END					; END => set alpha-channel to full transparency
	jz	@f
	mov	alpha,0
	jmp	@slwa
@@:
	invoke	IsKey,VK_HOME					; HOME => set alpha-channel to full opacity
	jz	@f
	mov	alpha,255
	jmp	@slwa
@@:
	invoke	IsKey,VK_NEXT					; PAGE DOWN => alpha -1
	jz	@f
	.if	alpha > 0
		dec	alpha
	.else
		mov	alpha,0
	.endif
	jmp	@slwa
@@:
	invoke	IsKey,VK_PRIOR					; PAGE UP => alpha +1
	jz	@loop
	.if	alpha < 255
		inc	alpha
	.else
		mov	alpha,255
	.endif
@slwa:
  invoke SetLayeredWindowAttributes,hwin,0,alpha,LWA_ALPHA	; crKey(0), bAlpha(alpha), dwFlags(2=LWA_ALPHA)
  jmp	@loop3
@exit:
;  invoke SelectObject,hdc,hfntold
;  invoke DeleteObject,hfont
  invoke ReleaseDC,hdesk,hdc
  invoke DeleteObject,hbr_x
  invoke DeleteObject,hbr_r
  invoke DeleteObject,hrgn
  invoke DeleteObject,hrgn0
  invoke DeleteObject,hrgn2
  invoke SendMessageTimeout,hdesk,WM_SETTEXT,0,addr bufdesk,SMTO_ABORTIFHUNG,20,0
  invoke InvalidateRect,0,0,1
@quit:
  invoke ExitProcess,0
end start
